

import sys

from PyQt5.QtWidgets import QApplication
from PyQt5.QtCore import QObject, QUrl, pyqtSlot
from PyQt5.QtQml import QQmlApplicationEngine, qmlRegisterType



class Controller( QObject ):

    def __init__( self, parent = None, **kwargs ):
        super( Controller, self).__init__( parent = parent, **kwargs )

    @pyqtSlot( QObject )
    def initialise( self , item ) :
        data = item.getStuff()

        try :
            print( "running section 1" )
            print( "print( data ) :" )
            print( data )
            print( 'print( data.property( "good" ) ) :' )
            print( data.property( "good" ) )
            print( 'print( data.property( "texts" ) ) :' )
            print( data.property( "texts" ) )
        except Exception as e :
            print( "-- error running section 1 -- " )
            print( e )
        else:
            print( "-- finish running section 1 -- " )

        try:
            print( "running section 2" )
            print( "print( data ) :" )
            print( data )
            print( "print( isinstance( data , dict ) ) :" )
            print( isinstance( data , dict ) )
            print( 'print( data["good"] )' )
            print( data["good"] )
            print( 'print( isinstance( data["texts"] , list ) )' )
            print( isinstance( data["texts"] , list ) )
            print( 'print( data["texts"][0].property( "text" ) )' )
            print( data["texts"][0].property( "text" ) )
        except Exception as e:
            print( "-- error running section 2 --" )
            print( e )
        else:
            print( "-- finish running section 2 --" )



qmlRegisterType( Controller , "Controller" , 1, 0, "Controller"  )

app = QApplication(sys.argv)

engine = QQmlApplicationEngine( QUrl( "./app.qml" ) )
topLevelWindow = engine.rootObjects()[0]
topLevelWindow.show()

sys.exit( app.exec_() )
